/*
  a basic player
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include "guiPlayer5.h"



GuiPlayer::GuiPlayer() { 
  resize(200,120);
  OutputDevice* outputDevice;


  b = new QBoxLayout( this, QBoxLayout::LeftToRight, 5 );


  multicastDevice = new MulticastDevice();

  guiVolumeDevice = new GuiVolumeDevice(this);
  guiVolumeDevice->buildGui();
  guiVolumeDevice->setFilter(true);
  guiVolumeDevice->setGeometry( 10, 10, 180, 180 );
  guiVolumeDevice->show();
  outputDevice=guiVolumeDevice->getDevice();

  b->addWidget(guiVolumeDevice , AlignLeft|AlignTop|AlignBottom );



  audioDevice = new AudioDeviceLinux("/dev/dsp",true);
  multicastDevice->addListener(outputDevice);
  outputDevice->addListener(audioDevice);


  // You should make sure that all devices are initialized
  // Most of them does not need an "openDevice" call but
  // the audioDevice _does_
  // A common error is to not open the device and put
  // them in a yafDecoder. But the yafDecoder then blocks
  // because he does not get the preffered Buffersize
  // of the devices. Alwas make sure your devices are open!
  audioDevice->openDevice();

}


GuiPlayer::~GuiPlayer() {
  // Every device in the tree must be deleted seperatley:
  delete audioDevice;
  delete multicastDevice;
}

/*
  The yafDecoder cannot be handled like an ordinary
  device (on this level).
*/
void GuiPlayer::setGenericStreamProducer(GenericStreamProducer* aDecoder) {
  MetaPlayer::setGenericStreamProducer(aDecoder);
}



OutputDevice* GuiPlayer::getInternalDeviceTree() {
  // this method is used by the metaPlayer. It return
  // the root node of the devicetree.
  return multicastDevice;
}



