/*
  simple control gui for a device
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */




#include <deviceWidgets/guiTimerDevice.h>



GuiTimerDevice::GuiTimerDevice(QWidget *parent=0, 
			       const char *name=0):GuiDevice( parent, name ) {

  buffer=new Buffer(10);

  timerDevice=new TimerDevice();
  setMinimumSize( sizeHint() );

  setDevice(timerDevice);
  startTimer(500);       // 3 updates per second
}


GuiTimerDevice::~GuiTimerDevice() {
  delete buffer;
  delete timerDevice;
}

float GuiTimerDevice::getTime() {
  return timerDevice->getTime();
}

QSize GuiTimerDevice::sizeHint () {
  return QSize(40,40);
}


void GuiTimerDevice::paintEvent ( QPaintEvent * paintEvent ) {
  float time;
  QPainter paint;
  time=getTime();
  snprintf(buffer->getData(),10,"%f",time);
  paint.begin( this );
  paint.drawText(0,10,buffer->getData());
  paint.end();  
  
}







