/*
  mixes a DeviceConfigArray and delivers the result to the listeners
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <devices/mixerDevice.h>



MixerDevice::MixerDevice() {
  AudioBuffer* audioBuffer;

  pcmChunk=new MemChunk(_MAX_PCM_BUFFER);
  config=getDeviceConfig();

  audioBuffer=config->getAudioBuffer();
  audioBuffer->setMemChunk(pcmChunk);
  mixerFilter=new MixerFilter();
}


MixerDevice::~MixerDevice() {
  delete pcmChunk;
  delete mixerFilter;
}


void MixerDevice::writeOut(DeviceConfigArray* buf) {
  DeviceConfig* dummy;
  NodeDevice* nodeDevice;
  Edges* edges=getListeners();
  int n=edges->getElements();
  int i;
  
  mixerFilter->transform(buf,config);

  for(i=0;i<n;i++) {
    nodeDevice=edges->getNodeDevice(i);
    nodeDevice->writeInLock();
    nodeDevice->writeIn(this,config);
    nodeDevice->writeInUnlock();
  }
  

}


  
